using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.InteropServices;

namespace rfid
{
  class GIS_HRW_API
  {
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_LibVersion();
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_IsVirtualComInstalled();
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_CountAllDevices();
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_ListAllDeviceNames(Byte[] NamenListe, int nBufferSize);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_ListAllDeviceNamesEx(Byte[] NamenListe, int nBufferSize);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_GetAvailablePorts(Byte[] NamenListe, int nBufferSize);

    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_LanListAllDeviceNames(Byte[] NamenListe, int nBufferSize);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_LanConfigListDevices(Byte[] Buffer, int nBufferSize);

    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_LanChangeIPAddress(string OldAddress, string NewAddress, string IPMask);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_LanIsDeviceAvailable(string Address);

    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_LanConfigOpen(string strName);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_LanConfigGet(int nHandle, int RecordNr, Byte[] pData, int Len);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_LanConfigSet(int nHandle, int RecordNr, Byte[] pData, int Len);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_LanConfigClose(int nHandle,int Reset);

    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_HIDConfigRead(int PortHandle, Byte[] pSendBuf, int SendBufLen,Byte[] pRecvBuf, int RecvBufLen);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_HIDConfigWrite(int PortHandle, Byte[] pSendBuf, int SendBufLen);

    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_BT_SetPin (int PortHandle,Byte[] Pin);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_BT_GetPin (int PortHandle,Byte[]Pin);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_BT_SetLocalName(int PortHandle, Byte[] LocalName);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_BT_GetLocalName(int PortHandle, Byte[]LocalName);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_BT_GetLocalBTAddr(int PortHandle, Byte[] LocalAddr);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_BT_SetOperationMode(int PortHandle, int Mode);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_BT_GetOperationMode(int PortHandle, int * pMode);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_BT_SetValidPorts(int PortHandle, int Ports);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_BT_GetValidPorts(int PortHandle, int * pPorts);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_BT_SetEventFilter(int PortHandle, int Filter);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_BT_GetEventFilter(int PortHandle, int * pFilter);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_BT_SetDeviceClass(int PortHandle, int DevClass);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_BT_ChangeUARTSpeed(int PortHandle, int SpeedIdx);

    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_BT_ListAllDeviceNames(Byte[] Buffer, int nBufferSize);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_BT_Search (int PortHandle, Byte[] DeviceList, int nBufferSize, int Timeout , DWORD ClassFilter);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_BT_Connect(int PortHandle, Byte[] Device, BYTE RemotePortNr, int Timeout);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_BT_CheckConnection(int PortHandle);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_BT_Disconnect(int PortHandle);

    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_OpenPort(LPCTSTR Name,int Baudrate,int Timeout);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_ClosePort(int handle);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_KeepAppActive(int handle,int bActive);

    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_SetReaderAdresse(int handle,int Adresse);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_DeviceVersion(int PortHandle, Byte[] pBuffer, int BufLen);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_IsUSB(int handle);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_SetBaudrate(int handle, int Baudrate, int ParityMode);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_SetReaderMode(int handle,int mode);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_SetRF(int handle,int OnOff);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_SetIO(int handle,int Maske, int OutWert);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_ReadIO(int handle);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_GetLastError(int handle);

    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_ReadSerialNumber(int handle, Byte[] pSerial, int Buflen);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_SetConfig(int handle,Byte[] pConfig, int ConfigLen);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_GetConfig(int handle,Byte[] pConfig, int ConfigLen);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_SetDefault(int handle);

    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_GetActivationContext(int handle, Byte[] pData, int Len);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_WriteActivationContext(int handle, Byte[] pData, int Len);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_ReadCounter(int handle, int * pCounter);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_DecrementCounter(int handle, int * pNewCounter);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_GetDaysRemain(int handle, int * pDaysRemain);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_UpdateDaysRemain(int handle, int * pDaysRemain);

    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_SetCommunicationMode(int handle, int Mode);

    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_RawWrite(int handle,Byte[] pBuffer, int BufLen);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_RawRead(int handle,Byte[] pBuffer, int BufLen);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_Transfer(int PortHandle, Byte[] pSendBuf, int SendBufLen,Byte[] pRecvBuf, int RecvBufLen);

    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_ReadRegister(int handle, int Register, Byte[]pVal);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_WriteRegister(int handle, int Register, BYTE Val);

    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_ReadEEProm(int handle, int StartAdresse, Byte[] pData, int Len);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_WriteEEProm(int handle, int StartAdresse, Byte[] pData, int Len);

    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_ISO_Inventory(int handle,Byte[] pBuffer,int BufLen,int nRequestFlag);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_ISO_InventoryAFI(int handle,Byte[] pBuffer,int BufLen,int nRequestFlag,int AFI);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_ISO_GetSystemInfo(int handle,Byte[] pBuffer,int BufLen, Byte[] pUID, int UIDLen,int nRequestFlag);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_ISO_ReadSingleBlock(int handle,int nBlock,Byte[] pBuffer,int BufLen,Byte[] pUID,int UIDLen,int nRequestFlag);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_ISO_ReadMultipleBlocks(int handle,int nFirstBlock,int nNumberOfBlocks,Byte[] pBuffer,int BufLen,Byte[] pUID,int UIDLen,int nRequestFlag);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_ISO_WriteSingleBlock(int handle,int nBlock,Byte[] pBuffer,int BufLen,Byte[] pUID,int UIDLen,int nRequestFlag);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_ISO_SetAirProtokoll(int handle,int nAirSettings);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_ISO_GetAirProtokoll(int handle,int * nAirSettings);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_ISO_GetTagInfo(int handle,Byte[] pUID, int UIDLen,int* BlockAnzahl,int* BytesProBlock,int* MfgCode,int nRequestFlag);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_ISO_LockBlock(int handle,int nBlock,Byte[] pUID,int UIDLen,int nRequestFlag);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_ISO_StayQuiet(int handle,Byte[] pUID,int UIDLen,int nRequestFlag);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_ISO_Select(int handle,Byte[] pUID,int UIDLen,int nRequestFlag);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_ISO_ResetToReady(int handle,Byte[] pUID,int UIDLen,int nRequestFlag);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_ISO_GetMultipleBlockSecurityStatus(int handle,int nFirstBlock,int nNumberOfBlocks,Byte[] pBuffer,int BufLen,Byte[] pUID,int UIDLen,int nRequestFlag);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_ISO_WriteAFI(int handle,int AFI,Byte[] pUID,int UIDLen,int nRequestFlag);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_ISO_LockAFI(int handle,Byte[] pUID,int UIDLen,int nRequestFlag);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_ISO_WriteDSFID(int handle,int DSFID,Byte[] pUID,int UIDLen,int nRequestFlag);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_ISO_LockDSFID(int handle,Byte[] pUID,int UIDLen,int nRequestFlag);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_ISO_RawRequest(int handle,int nRequestFlag, int nKommando, Byte[] pParam, int nParamLen, Byte[] pData, int nDataLen,Byte[] pReceive, int nReceiveLen);

    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_WriteTiming(int handle,int nTiming);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_SetComparator(int handle,Byte[] pParam, int nParamLen);

    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_Mifare_Request(int handle,WORD *pATQA);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_Mifare_RequestAll(int handle,WORD *pATQA);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_Mifare_Select(int handle, Byte[] pUID, int nUIDLen, Byte[] pSAK);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_Mifare_SelectUID(int handle, Byte[] pUID, int nUIDLen, Byte[] pSAK);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_Mifare_Halt(int handle);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_MifareSetKey(int handle, int KeyType, int nAdresse, Byte[] pKey, int nKeyLen);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_MifareAuthenticate(int handle, Byte[] pUID, int nUIDLen, int KeyType, int nAdresse, int BlockNr);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_MifareAuthenticateDirect(int handle, Byte[] pUID, int nUIDLen, int KeyType, Byte[] pKey, int nKeyLen, int BlockNr);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_MifareRead       (int handle, int BlockNr, Byte[] pData, int nDataLen);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_MifareWrite      (int handle, int BlockNr, Byte[] pData, int nDataLen);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_MifareGetValue   (int handle, int BlockNr, int *pValue);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_MifareSetValue   (int handle, int BlockNr, int Value);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_MifareChangeValue(int handle, int BlockNr, int Richtung, int Differenz);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_ISO14443SetCID   (int handle, int CID);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_ISO14443Rats     (int handle, BYTE[] pData, int  MaxDataLen);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_ISO14443PPS      (int handle, int Speed);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_ISO14443Transmit (int handle, BYTE[] pSendData, int nSendLen, BYTE[] pRecvData, int RecvLen);

    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_WriteParam(int handle,Byte[] pBuffer, int BufLen);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_ReadParam(int handle,Byte[] pBuffer, int BufLen);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_WritePrefix(int handle,Byte[] pBuffer, int BufLen);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_ReadPrefix(int handle,Byte[] pBuffer, int BufLen);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_WriteSuffix(int handle,Byte[] pBuffer, int BufLen);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_ReadSuffix(int handle,Byte[] pBuffer, int BufLen);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_WriteTermix(int handle,Byte[] pBuffer, int BufLen);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_ReadTermix(int handle,Byte[] pBuffer, int BufLen);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_WritePostcode(int handle,Byte[] pBuffer, int BufLen);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_ReadPostcode(int handle,Byte[] pBuffer, int BufLen);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_WriteReadModeParam(int handle,Byte[] pBuffer, int BufLen);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_ReadReadModeParam(int handle,Byte[] pBuffer, int BufLen);
    [DllImport("TS_HRW_SDK.dll")] public static extern int TSHRW_WriteMifareKey(int handle, int KeyType, Byte[] pKey, int KeyLen);

    public GIS_HRW_API()
    {
    }
  }
}
